import React, { useState } from 'react'

export default function IFrameVisualization({ src }) {

    const [html, setHtml] = useState(null)
    const [classes, setClasses] = useState('hidden iframe-visualization')

    if (!html) {
        fetch(src)
            .then(res => res.text())
            .then(data => setHtml(data))
            .catch(err => console.log(err.message))
    }

    return (
        <iframe
            onLoad={() => setClasses('iframe-visualization')}
            allowTransparency='true'
            className={classes}
            title='Gods of Space'
            srcDoc={html}
        />
    )
}
